
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module DE0_NANO_SOC_RTL_MTL2GP0_D5MGP1(
	//////////// ADC //////////
	output		          		ADC_CONVST,
	output		          		ADC_SCK,
	output		          		ADC_SDI,
	input 		          		ADC_SDO,

	//////////// ARDUINO //////////
	inout 		    [15:0]		ARDUINO_IO,
	inout 		          		ARDUINO_RESET_N,

	//////////// CLOCK //////////
	input 		          		FPGA_CLK1_50,
	input 		          		FPGA_CLK2_50,
	input 		          		FPGA_CLK3_50,

	//////////// KEY //////////
	input 		     [1:0]		KEY,

	//////////// LED //////////
	output		     [7:0]		LED,

	//////////// SW //////////
	input 		     [3:0]		SW,

	//////////// GPIO_0, GPIO connect to MTL2 - Multi-Touch LCD Panel //////////
	output		     [7:0]		MTL_B,
	output		          		MTL_DCLK,
	output		     [7:0]		MTL_G,
	output		          		MTL_HSD,
	output		     [7:0]		MTL_R,
	output		          		MTL_VSD,

	output		          		MTL_TOUCH_I2C_SCL,
	inout 		          		MTL_TOUCH_I2C_SDA,
	input 		          		MTL_TOUCH_INT_n,

	//////////// GPIO_1, GPIO connect to D5M - 5M Pixel Camera //////////
	input 		    [11:0]		D5M_D,
	input 		          		D5M_FVAL,
	input 		          		D5M_LVAL,
	input 		          		D5M_PIXCLK,
	output		          		D5M_RESET_N,
	output		          		D5M_SCLK,
	inout 		          		D5M_SDATA,	
	input 		          		D5M_STROBE,
	output		          		D5M_TRIGGER,
	output		          		D5M_XCLKIN
);

//=======================================================
//  REG/WIRE declarations
//=======================================================
//---SYSTEM RESET-----
   wire         RESET_N  ; 

//--D5M CMOS SENSOR PROCESSER--
   wire   [11:0]sCCD_R;
   wire   [11:0]sCCD_G;
   wire   [11:0]sCCD_B;
   wire   		 CCD_DVAL;
   wire			 CCD_LDVAL ;
   wire			 CCD_FDVAL ;
	
//---MTL TOUCH PROCESSER ----- 
   wire [11:0] UPX;
	wire [11:0] UPY;
   wire [11:0] NEW_X;
	wire [11:0] NEW_Y;	

//---CLOCK TEST -----
   wire D5M_PIXCLK_test ; 		
   wire MTL_DCLK_test ; 	

//=======================================================
//  Structural coding
//=======================================================

//-- SYSTEM RESET 
assign  RESET_N = KEY[0] ; 

//--D5M CMOS SENSOR PROCESSER--
D5M_SET   ccd (
	.RESET_SYS_N(RESET_N),
   .CLOCK_50   (FPGA_CLK2_50 ),
	.D5M_D      (D5M_D) ,
	.D5M_FVAL   (D5M_FVAL),
	.D5M_LVAL   (D5M_LVAL),
	.D5M_PIXCLK (D5M_PIXCLK),
	
	.D5M_RESET_N(D5M_RESET_N),
	.D5M_SCLK   (D5M_SCLK),
	.D5M_SDATA  (D5M_SDATA),
	
	.D5M_STROBE (D5M_STROBE),
	.D5M_TRIGGER(D5M_TRIGGER),
	.D5M_XCLKIN (D5M_XCLKIN),
  
	.sCCD_R     (sCCD_R),
	.sCCD_G     (sCCD_G),
	.sCCD_B     (sCCD_B),
	
	.CCD_DVAL   (CCD_DVAL),	
	.CCD_LDVAL  (CCD_LDVAL),
   .CCD_FDVAL  (CCD_FDVAL)	
);


//--- MTL2_TOUCH PROCESS & TOUCH NEW X-Y 
 MTL2_TOUCH_SET   mtlt( 
   .CLK_50            (FPGA_CLK1_50), 
   .RESET_N           (RESET_N),	
   .MTL_TOUCH_I2C_SCL (MTL_TOUCH_I2C_SCL), 	
   .MTL_TOUCH_I2C_SDA (MTL_TOUCH_I2C_SDA),	
   .MTL_TOUCH_INT_n   (MTL_TOUCH_INT_n  ),
   .MTL_VSD           (MTL_VSD          ),

	.TOUCH1_XH         (), 
	.TOUCH1_XL         (),  
	.TOUCH1_YH         (),  
   .TOUCH1_YL         (),  

   .UPX               (UPX  ),
	.UPY               (UPY  ),
   .NEW_X             (NEW_X),
	.NEW_Y	          (NEW_Y)
) ; 

//-------MTL2 display 320X240 24bit RGB  ---- 
MTL2_320X240_RGB24BIT   mtl2_d(
 .CLK_50    (FPGA_CLK1_50), 
 .RESET_N   (RESET_N     ), 
 .D5M_PIXCLK(D5M_PIXCLK  ),
 .D5M_FVAL  (D5M_FVAL    ),
 .D5M_LVAL  (D5M_LVAL    ),
 .CCD_DVAL  (CCD_DVAL    ),
 .CCD_LDVAL (CCD_LDVAL   ),
 .CCD_FDVAL (CCD_FDVAL 	 ),
 .CCD_R     (sCCD_R[11:4]),   
 .CCD_G     (sCCD_G[11:4]),   
 .CCD_B     (sCCD_B[11:4]),  
 .UPX       (UPX         ),      
 .UPY       (UPY         ),      
 .MTL_R     (MTL_R       ),  
 .MTL_G     (MTL_G       ), 
 .MTL_B     (MTL_B       ), 
 .MTL_HSD   (MTL_HSD     ),
 .MTL_VSD   (MTL_VSD     ),
 .MTL_DCLK  (MTL_DCLK    )
 
); 						


//---D5M DOT CLOCK 25MHZ TEST  , if OK! will output 1HZ--- 	
CLOCKMEM d5mc (.CLK( D5M_PIXCLK ) ,.CLK_FREQ(25000000) ,.CK_1HZ (D5M_PIXCLK_test) ) ;		

//---MTL2 PIXEL CLOCK 33MHZ TEST , if OK! will output 1HZ--- 	
CLOCKMEM mtl2c(.CLK( MTL_DCLK )   ,.CLK_FREQ(33000000) ,.CK_1HZ (MTL_DCLK_test ) ) ;	

//---LED STATUS--- 
assign LED = {D5M_PIXCLK_test , MTL_DCLK_test, MTL_DCLK MTL_TOUCH_INT_n  };	 

endmodule
