module MTL2_320X240_RGB24BIT  (
 input       CLK_50 , 
 input       RESET_N  , 
 //--------D5M INPUT 
 input       D5M_PIXCLK,
 input       D5M_FVAL ,
 input       D5M_LVAL ,
 input       CCD_DVAL ,
 input       CCD_LDVAL,
 input       CCD_FDVAL,
 input [7:0] CCD_R ,   
 input [7:0] CCD_G ,   
 input [7:0] CCD_B ,  
//--------TOUCH NEW X Y  --  
 input [11:0] UPX ,      
 input [11:0] UPY ,      
 
 //---------TO MTL2 DISPLAY---
 output [7:0] MTL_R  ,  
 output [7:0] MTL_G  , 
 output [7:0] MTL_B  , 
 output       MTL_HSD  ,
 output       MTL_VSD  ,
 output       MTL_DCLK 
 
); 
//----MTL2 DISPLAY 320 X 240 RGB
   wire       MTL_CLK  ; // 33MHZ

//---SRAM-BASE FRAME BUFFER---
   wire       RD_VALID ; 
   wire [7:0] sMTL_R;
   wire [7:0] sMTL_G;
   wire [7:0] sMTL_B; 

//---------VGA---
   wire [11:0] H_Cont;
   wire [11:0] V_Cont;	

//---SRAM-BASE FRAME BUFFER---

FRAME_RAM_CTRL frb(
  .D5M_PIXCLK ( D5M_PIXCLK), 
  .D5M_FVAL   ( D5M_FVAL  ),
  .D5M_LVAL   ( D5M_LVAL  ),
  .CCD_DVAL   ( CCD_DVAL  ),
  .CCD_LDVAL  ( CCD_LDVAL )  , 
  .CCD_FDVAL  ( CCD_FDVAL )	 ,
  .CCD_R      ( CCD_R     ),//sCCD_R[11:4]),
  .CCD_G      ( CCD_G     ),//sCCD_G[11:4]),
  .CCD_B      ( CCD_B     ),//sCCD_B[11:4]),
  .H_OFFSET   ( UPX       ),
  .V_OFFSET   ( UPY       ),
  
  .H_Cont     ( H_Cont    ), 
  .V_Cont     ( V_Cont    ),
  .MTL_DCLK   ( MTL_DCLK  ),
  .MTL_VSD    ( MTL_VSD   ),
  .MTL_R      ( sMTL_R    ),
  .MTL_G      ( sMTL_G    ),
  .MTL_B      ( sMTL_B    ),
  .RD_VALID   ( RD_VALID  )
);

//---------MTL2 DISPLAY CLOCK---
PLL_VGA (
	.refclk  ( CLK_50 ),   
	.rst     ( 0 ),     
	.outclk_0( MTL_CLK), // 33MHZ
	.locked  ( )   
	);
//---------VGA(MTL2) CONTROLLER ---
VGA_Controller vc(	//	Host Side
	.iRed       (RD_VALID?sMTL_R:0),
	.iGreen     (RD_VALID?sMTL_G:0),
	.iBlue      (RD_VALID?sMTL_B:0),
	
	.oRequest   ( ),
	//	VGA Side
	.oVGA_R     (MTL_R   ),
	.oVGA_G     (MTL_G   ),
	.oVGA_B     (MTL_B   ),
	.oVGA_H_SYNC(MTL_HSD ),
	.oVGA_V_SYNC(MTL_VSD ),
	
	.oVGA_BLANK (),
	.oVGA_CLOCK (MTL_DCLK ),
	//	Control Signal
	.iCLK       (MTL_CLK ),
	.iRST_N     (RESET_N  ) ,
	.H_Cont     ( H_Cont),
   .V_Cont     ( V_Cont)
);

endmodule 