module MTL2_TOUCH_SET   ( 
   input        CLK_50 , 
   output       MTL_TOUCH_I2C_SCL, 	
   inout        MTL_TOUCH_I2C_SDA, 	
   input        MTL_TOUCH_INT_n,   
   input        MTL_VSD,
   input        RESET_N,

	output [7:0] TOUCH1_XH, 
	output [7:0] TOUCH1_XL,  
	output [7:0] TOUCH1_YH,  
   output [7:0] TOUCH1_YL,  

   output [11:0]UPX,
	output [11:0]UPY,
   output [11:0]NEW_X,
	output [11:0]NEW_Y	
) ; 
//=======================================================
//  REG/WIRE declarations
//=======================================================

//---TOUCH PROCESSER -----
	wire [7:0] ID_G_CIPHER;
	wire [7:0] GEST_ID;        
	wire [7:0] TD_STATUS;
  
	wire       UPDATE_F;


//=======================================================
//  Structural coding
//=======================================================	
	
	
//---TOUCH PROCESSER -----	
TOUCH_I2C i2c( 
   .RESET_N    ( RESET_N  )  ,
   .CLK_50     ( CLK_50 ),
   .I2C_SCL    ( MTL_TOUCH_I2C_SCL  ), 
   .I2C_SDA    ( MTL_TOUCH_I2C_SDA  ),
   .INT_n      ( MTL_TOUCH_INT_n    ),

	.ID_G_CIPHER(  ID_G_CIPHER),
	.GEST_ID    (  GEST_ID    ),        
	.TD_STATUS  (  TD_STATUS  ), 
	.TOUCH1_XH  (  TOUCH1_XH  ),  
	.TOUCH1_XL  (  TOUCH1_XL  ),  
	.TOUCH1_YH  (  TOUCH1_YH  ),  
   .TOUCH1_YL  (  TOUCH1_YL  ),  
	.UPDATE_F   (  UPDATE_F), 	
   .UPX        (  NEW_X     ), 
	.UPY        (  NEW_Y     )
	);

//---WINDOWS LOCATION UPDATE---
TOUCH_UPDATE   th( 
 .NEW_X (NEW_X),
 .NEW_Y (NEW_Y),
 .UPX(UPX),
 .UPY(UPY),
 .UPDATE_N ( MTL_VSD ),
 .RESET_N  ( RESET_N )
); 

endmodule 