module TOUCH_I2C ( 
   input   RESET_N , 
   input   CLK_50 ,
	
   output I2C_SCL, 
   inout  I2C_SDA,
   input  INT_n,
	
//----SET     N --- 	

//----Test or ST-BUS --- 
	output reg [7:0]ID_G_CIPHER,
	output reg [7:0]GEST_ID,        
	output reg [7:0]TD_STATUS, 
	output reg [7:0]TOUCH1_XH,  
	output reg [7:0]TOUCH1_XL,  
	output reg [7:0]TOUCH1_YH,  
   output reg [7:0]TOUCH1_YL,  
	output reg UPDATE_F, 	
   output reg [11:0]UPX , 
	output reg [11:0]UPY ,
	
	//test
	output reg  CLK_400K ,
   output reg  I2C_LO0P,
   output reg [7:0] ST ,
   output reg [7:0] CNT,
	output reg [7:0] WCNT,
   output reg [7:0] W_WORD_DATA,
   output reg [7:0] W_POINTER_REG,
	
	output           W_WORD_END ,
   output reg       W_WORD_GO ,
	
	output [7:0] WORD_ST,
	output [7:0] WORD_CNT,
	output [7:0] WORD_BYTE	,
   output [7:0] R_DATA,
	output SDAI_W ,
	output reg REP_RQ ,
	output TR 
	
	);
	

	
	
//-- I2C clock 400k generater 
//reg  CLK_400K; 
reg  [31:0]C_DELAY ;
always @(posedge CLK_50 ) begin 
  if ( C_DELAY > 125/2 ) begin  
    CLK_400K<=~CLK_400K ; C_DELAY <= 0 ; 
  end 
  else C_DELAY <=C_DELAY +1 ; 
end
  
//======== Main-ST =======
//==Pointer NUM==
parameter    SLAVE_ADDR          =8'h70;  

//-WRITE-
parameter    P_DEVIDE_MODE  =8'h00;

//-READ-
parameter    P_ID_G_CIPHER =8'hA3;
parameter    P_GEST_ID     =8'h01;
parameter    P_TD_STATUS   =8'h02;
parameter    P_TOUCH1_XH   =8'h03;
parameter    P_TOUCH1_XL   =8'h04; 
parameter    P_TOUCH1_YH   =8'h05;
parameter    P_TOUCH1_YL   =8'h06; 
//----
wire [11:0] T_X ;
wire [11:0] T_Y ;

assign T_X ={TOUCH1_XH[3:0] , TOUCH1_XL[7:0]};
assign T_Y ={TOUCH1_YH[3:0] , TOUCH1_YL[7:0]};

reg [31:0] DELY ;

always @(negedge RESET_N or posedge CLK_400K )begin 
if (!RESET_N  ) ST <=0;
else 
case (ST)
0: begin 
   ST<=30; //Config Reg
	W_POINTER_GO <=1;
   R_GO  <=1 ;		 
	W_WORD_GO <=1;
	REP_RQ <= 0;
	WCNT <=0;  CNT <=0;
	DELY <=0 ; 
	UPX <= 575;
	UPY <= 373;
	
   end
//<----------------READ -------	
1: begin 
   ST<=2; 
	end	
2: begin 
	     if ( CNT==0)  W_POINTER_REG <= P_ID_G_CIPHER;
	else if ( CNT==1)  W_POINTER_REG <= P_GEST_ID    ;    
	else if ( CNT==2)  W_POINTER_REG <= P_TD_STATUS;  
   else if ( CNT==6)  W_POINTER_REG <= P_TOUCH1_XH;  
   else if ( CNT==5)  W_POINTER_REG <= P_TOUCH1_XL;  
   else if ( CNT==3)  W_POINTER_REG <= P_TOUCH1_YH;  
   else if ( CNT==4)  W_POINTER_REG <= P_TOUCH1_YL  ;	
	if ( W_POINTER_END ) begin  W_POINTER_GO  <=0; ST<=3 ; DELY<=0;  end
	end                // Write pointer
3: begin 
    DELY  <=DELY +1;
    if ( DELY ==2 ) begin 
     W_POINTER_GO  <=1;
     ST<=4 ; 
	 end

	end       
4: begin 
   if  ( W_POINTER_END ) ST<=5 ; 	
	end              
5: begin ST<=6 ; end //delay
	
//read DATA 		 
6: begin 
	if ( R_END ) begin  R_GO  <=0; ST<=7 ; DELY<=0; end
	end                
7: begin 
    DELY  <=DELY +1;
    if ( DELY ==2 ) begin 	 
    R_GO  <=1;
    ST<=8 ; 
	 end
	 
	end       
8: begin 
   ST<=9 ; 
	end       
	
9: begin 
   if  ( R_END ) begin 
	       if ( CNT==0) ID_G_CIPHER<=R_DATA ; 
	  else if ( CNT==1) GEST_ID    <=R_DATA ;      
	  else if ( CNT==2) TD_STATUS  <=R_DATA ;      
	  else if ( CNT==6) TOUCH1_XH  <=R_DATA ; 
     else if ( CNT==5) TOUCH1_XL  <=R_DATA ; 
     else if ( CNT==3) TOUCH1_YH  <=R_DATA ; 
     else if ( CNT==4) TOUCH1_YL  <=R_DATA ; 
	  CNT<=CNT+1 ;
	  ST<=10 ; 	
	end 
  end	
10: begin   
     if (CNT ==7) begin  CNT <= 0 ;  end
	     ST<=1;
		  DELY <=0;
	     W_POINTER_GO <=1;
        R_GO         <=1 ;		 
	     W_WORD_GO    <=1; 
		  
		  if ( TOUCH1_XH[7:6] == 2'b10 )  begin  
		    UPDATE_F<=1 ;  
			 UPX <= (T_X > 240 )?T_X: 240 ;// UPX; 
			 UPY <= (T_Y > 150 )?T_Y: 150 ;// UPY; 
			 end 
		   else UPDATE_F<=0 ;   
		  
		  
	 end //delay
//<----------------------------------READ-----------------------	  
//<----------------------------------WRITE WORD-----------------
29: begin 
    if (DELY < 10 ) DELY <=DELY+1; 
	 else  ST<=30; 
    end	

30: begin 
    ST<=31; 
	 WCNT<=0 ; 
    end	
31: begin 
				 if ( WCNT==0) begin {W_POINTER_REG[7:0] ,W_WORD_DATA[7:0]} <= { P_DEVIDE_MODE ,8'h00};  end					
	if (  W_WORD_END ) begin  W_WORD_GO  <=0; ST<=32 ;  DELY<=0;  end
	end                // Write ID pointer 
32: begin 
    DELY  <=DELY +1;
    if ( DELY ==3 ) begin 
    W_WORD_GO  <=1;
    ST<=33 ; 
	 end
	 
	end       
33: begin 
    ST<=34 ; 
	end       	
34: begin 
     if  ( W_WORD_END )  begin 	
			 WCNT<=WCNT+1 ;			 
			 ST<=35 ; 
	  end
	end              
35: begin 
    if (WCNT ==1)  begin ST<=1 ;  WCNT <=0;  CNT <=0;I2C_LO0P <= ~I2C_LO0P ; end 
	 else  ST<=31 ; 	 
	 end 
endcase 
end
//<-----------------------------MAIN-ST END ------------------------------------------
//I2C-BUS
assign I2C_SCL       = W_POINTER_SCL  & R_SCL   & W_WORD_SCL;
assign SDAO          = W_POINTER_SDAO & R_SDAO  & W_WORD_SDAO;
assign I2C_SDA = (SDAO)?1'bz :1'b0 ; 


//==== I2C WRITE WORD ===

wire   W_WORD_SCL ; 
wire   W_WORD_SDAO ;  

I2C_WRITE_BYTE  wrd(
   .RESET_N      (RESET_N),
	.PT_CK        (CLK_400K),
	.GO           (W_WORD_GO),
	.LIGHT_INT    (),
	.POINTER      (W_POINTER_REG),
   .WDATA8	     (W_WORD_DATA),
	.SLAVE_ADDRESS(SLAVE_ADDR ),
	.SDAI  (I2C_SDA),
	.SDAO  (W_WORD_SDAO),
	.SCLO  (W_WORD_SCL ),
	.END_OK(W_WORD_END),
	//--for test 
	.ST  (WORD_ST ),
	.CNT (WORD_CNT),
	.BYTE(WORD_BYTE),
	.ACK_OK(),
	.SDAI_W (SDAI_W )
	
);

//==== I2C WRITE POINTER ===
wire   W_POINTER_SCL ; 
wire   W_POINTER_END ; 
reg    W_POINTER_GO ; 
wire   W_POINTER_SDAO ;  

I2C_WRITE_POINTER  wpt(
   .RESET_N (RESET_N),
	.PT_CK        (CLK_400K),
	.GO           (W_POINTER_GO),
	.POINTER      (W_POINTER_REG),
	.SLAVE_ADDRESS(SLAVE_ADDR ),//37
	.SDAI  (I2C_SDA),
	.SDAO  (W_POINTER_SDAO),
	.SCLO  (W_POINTER_SCL ),
	.END_OK(W_POINTER_END),
	//--for test 
	.ST (),
	.ACK_OK(),
	.CNT (),
	.BYTE()  	
);


//==== I2C READ ===

wire R_SCL; 
wire R_END; 
reg  R_GO; 
wire R_SDAO;  


I2C_READ_BYTE rd( //
   .RESET_N (RESET_N),
	.PT_CK        (CLK_400K),
	.GO           (R_GO),
	.SLAVE_ADDRESS(SLAVE_ADDR ),
	.SDAI  (I2C_SDA),
	.SDAO  (R_SDAO),
	.SCLO  (R_SCL),
	.END_OK(R_END),
	.DATA8(R_DATA),
	//--for test 
	.ST    (),
	.ACK_OK(),
	.CNT   (),
	.BYTE  ()  	
);
	
endmodule
	